loci.formats.in.LeicaMicrosystemsMetadata

## Class LMSFileReader

- java.lang.Object
- - loci.formats.FormatHandler
  - - loci.formats.FormatReader
    - - loci.formats.in.LeicaMicrosystemsMetadata.LMSFileReader

- All Implemented Interfaces:
    java.io.Closeable, java.lang.AutoCloseable, ICompressedTileReader, IFormatHandler, IFormatReader, IMetadataConfigurable, IPyramidHandler
  Direct Known Subclasses:
    LOFReader, MultipleImagesReader, XLEFReader

      public abstract class LMSFileReader
      extends FormatReader

  This class can be extended by readers of Leica Microsystems file formats that include LASX generated XML (e.g. XLEF, LOF)
  Author:
    Melissa Linkert melissa at glencoesoftware.com, Constanze Wendlandt constanze.wendlandt at leica-microsystems.com

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `LMSFileReader.ImageFormat` file format in which actual image bytes are stored

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `LMSXmlDocument` | `associatedXmlDoc`
    `static org.slf4j.Logger` | `log`
    `MetadataTempBuffer` | `metaTemp`
    `static boolean` | `OLD_PHYSICAL_SIZE_DEFAULT`
    `static java.lang.String` | `OLD_PHYSICAL_SIZE_KEY`

    - ### Fields inherited from class loci.formats.FormatReader

      `core, coreIndex, datasetDescription, domains, fillColor, filterMetadata, flattenedResolutions, group, hasCompanionFiles, in, indexedAsRGB, metadata, metadataStore, normalizeData, resolution, saveOriginalMetadata, series, suffixNecessary, suffixSufficient, THUMBNAIL_DIMENSION`

    - ### Fields inherited from class loci.formats.FormatHandler

      `COMPRESSION_SUFFIXES, currentId, format, LOGGER, metadataOptions, suffixes`

    - ### Fields inherited from interface loci.formats.IFormatReader

      `CAN_GROUP, CANNOT_GROUP, MUST_GROUP`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `LMSFileReader(java.lang.String format, java.lang.String suffix)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addSeriesMeta(java.lang.String key, java.lang.Object value)` Adds an entry to the metadata table for the current series.
    `void` | `addSeriesMetaList(java.lang.String key, java.lang.Object value)` Add the given key/value pair to the current series metadata hashtable.
    `void` | `close(boolean fileOnly)` Closes the currently open file.
    `static boolean` | `fileExists(java.lang.String path)` Checks if file at path exists
    `java.util.List<CoreMetadata>` | `getCore()`
    `abstract LMSFileReader.ImageFormat` | `getImageFormat()` Returns the file format in which actual image bytes are stored
    `MetadataStore` | `makeFilterMetadata()` Return a properly configured loci.formats.meta.FilterMetadata.
    `void` | `setCore(java.util.ArrayList<CoreMetadata> core)`
    `void` | `translateMetadata(java.util.List<LMSImageXmlDocument> docs)` Extracts metadata from a list of Leica image XML Documents and writes them to the reader's CoreMetadata, `MetadataTempBuffer` and MetadataStore
    `void` | `translateMetadata(LMSImageXmlDocument doc)`
    `boolean` | `useOldPhysicalSizeCalculation()`

    - ### Methods inherited from class loci.formats.FormatReader

      `addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMeta, addGlobalMetaList, addMeta, addMetaList, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, addSeriesMeta, close, coreIndexToSeries, fileGroupOption, flattenHashtables, get16BitLookupTable, get8BitLookupTable, getAcquisitionMode, getAdvancedSeriesUsedFiles, getAdvancedUsedFiles, getArcType, getAvailableOptions, getBinning, getBitsPerPixel, getCompression, getContrastMethod, getCoreIndex, getCoreMetadataList, getCorrection, getCurrentCore, getCurrentFile, getDatasetStructureDescription, getDetectorType, getDimensionOrder, getDimensionOrder, getDomains, getEffectiveSizeC, getExperimentType, getFilamentType, getFillColor, getFillRule, getFilterType, getFontFamily, getFontStyle, getGlobalMeta, getGlobalMetadata, getIlluminationType, getImageCount, getImmersion, getIndex, getIndex, getLaserMedium, getLaserType, getMarker, getMedium, getMetadataStore, getMetadataStoreRoot, getMetadataValue, getMicrobeamManipulationType, getMicroscopeType, getModuloC, getModuloT, getModuloZ, getNamingConvention, getOptimalTileHeight, getOptimalTileWidth, getPixelType, getPixelType, getPossibleDomains, getPulse, getRequiredDirectories, getResolution, getResolutionCount, getRGBChannelCount, getRotationTransform, getSeries, getSeriesCount, getSeriesMeta, getSeriesMetadata, getSeriesMetadataValue, getSeriesUsedFiles, getSeriesUsedFiles, getSizeC, getSizeT, getSizeX, getSizeY, getSizeZ, getThumbSizeX, getThumbSizeY, getTileColumns, getTileRows, getUnderlyingReaders, getUsedFiles, getUsedFiles, getZCTCoords, getZCTModuloCoords, hasCompanionFiles, hasFlattenedResolutions, initFile, isFalseColor, isGroupFiles, isIndexed, isInterleaved, isInterleaved, isLittleEndian, isMetadataComplete, isMetadataFiltered, isNormalized, isOrderCertain, isOriginalMetadataPopulated, isRGB, isSingleFile, isThisType, isThisType, isThisType, isThisType, isThumbnailSeries, isUsedFile, openBytes, openBytes, openBytes, openBytes, openPlane, openThumbBytes, readPlane, readPlane, readPlane, reopenFile, seriesToCoreIndex, setCoreIndex, setFillColor, setFlattenedResolutions, setGroupFiles, setId, setMetadataFiltered, setMetadataStore, setNormalized, setOriginalMetadataPopulated, setResolution, setSeries, updateMetadataLists`

    - ### Methods inherited from class loci.formats.FormatHandler

      `checkSuffix, checkSuffix, getFormat, getMetadataOptions, getNativeDataType, getSuffixes, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface loci.formats.IFormatHandler

      `getFormat, getNativeDataType, getSuffixes`

    - ### Methods inherited from interface loci.formats.IMetadataConfigurable

      `getMetadataOptions, getSupportedMetadataLevels, setMetadataOptions`

    - ### Methods inherited from interface loci.formats.ICompressedTileReader

      `getTileCodec, getTileCodecOptions, openCompressedBytes, openCompressedBytes`

- - ### Field Detail

    - #### OLD_PHYSICAL_SIZE_KEY

          public static final java.lang.String OLD_PHYSICAL_SIZE_KEY

      See Also:
        Constant Field Values

    - #### OLD_PHYSICAL_SIZE_DEFAULT

          public static final boolean OLD_PHYSICAL_SIZE_DEFAULT

      See Also:
        Constant Field Values

    - #### log

          public static org.slf4j.Logger log

    - #### metaTemp

          public MetadataTempBuffer metaTemp

    - #### associatedXmlDoc

          public LMSXmlDocument associatedXmlDoc

  - ### Constructor Detail

    - #### LMSFileReader

          protected LMSFileReader(java.lang.String format,
                                  java.lang.String suffix)

  - ### Method Detail

    - #### close

          public void close(boolean fileOnly)
                     throws java.io.IOException

      Description copied from interface: `IFormatReader`
      Closes the currently open file. If the flag is set, this is all that happens; if unset, it is equivalent to calling `Closeable.close()`.
      Specified by:
        `close` in interface `IFormatReader`
      Overrides:
        `close` in class `FormatReader`
      Throws:
        `java.io.IOException`

    - #### getImageFormat

          public abstract LMSFileReader.ImageFormat getImageFormat()

      Returns the file format in which actual image bytes are stored

    - #### getCore

          public java.util.List<CoreMetadata> getCore()

    - #### setCore

          public void setCore(java.util.ArrayList<CoreMetadata> core)

    - #### useOldPhysicalSizeCalculation

          public boolean useOldPhysicalSizeCalculation()

    - #### addSeriesMeta

          public void addSeriesMeta(java.lang.String key,
                                    java.lang.Object value)

      Description copied from class: `FormatReader`
      Adds an entry to the metadata table for the current series.
      Overrides:
        `addSeriesMeta` in class `FormatReader`

    - #### addSeriesMetaList

          public void addSeriesMetaList(java.lang.String key,
                                        java.lang.Object value)

      Description copied from class: `FormatReader`
      Add the given key/value pair to the current series metadata hashtable. If the key already exists, a list will be stored in the hashtable and the value will be appended to the list.
      Overrides:
        `addSeriesMetaList` in class `FormatReader`

    - #### makeFilterMetadata

          public MetadataStore makeFilterMetadata()

      Description copied from class: `FormatReader`
      Return a properly configured loci.formats.meta.FilterMetadata.
      Overrides:
        `makeFilterMetadata` in class `FormatReader`

    - #### translateMetadata

          public void translateMetadata(java.util.List<LMSImageXmlDocument> docs)
                                 throws FormatException,
                                        java.io.IOException

      Extracts metadata from a list of Leica image XML Documents and writes them to the reader's CoreMetadata, `MetadataTempBuffer` and MetadataStore
      Parameters:
        `docs` - List of document nodes representing XML documents
      Throws:
        `FormatException`
        `java.io.IOException`

    - #### translateMetadata

          public void translateMetadata(LMSImageXmlDocument doc)
                                 throws FormatException,
                                        java.io.IOException

      Throws:
        `FormatException`
        `java.io.IOException`

    - #### fileExists

          public static boolean fileExists(java.lang.String path)

      Checks if file at path exists
      Parameters:
        `path` - whole file path

Copyright © 2026 Open Microscopy Environment